import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AnalyzeDocumentCommandInput, AnalyzeDocumentCommandOutput } from "../commands/AnalyzeDocumentCommand";
import { AnalyzeExpenseCommandInput, AnalyzeExpenseCommandOutput } from "../commands/AnalyzeExpenseCommand";
import { AnalyzeIDCommandInput, AnalyzeIDCommandOutput } from "../commands/AnalyzeIDCommand";
import { CreateAdapterCommandInput, CreateAdapterCommandOutput } from "../commands/CreateAdapterCommand";
import { CreateAdapterVersionCommandInput, CreateAdapterVersionCommandOutput } from "../commands/CreateAdapterVersionCommand";
import { DeleteAdapterCommandInput, DeleteAdapterCommandOutput } from "../commands/DeleteAdapterCommand";
import { DeleteAdapterVersionCommandInput, DeleteAdapterVersionCommandOutput } from "../commands/DeleteAdapterVersionCommand";
import { DetectDocumentTextCommandInput, DetectDocumentTextCommandOutput } from "../commands/DetectDocumentTextCommand";
import { GetAdapterCommandInput, GetAdapterCommandOutput } from "../commands/GetAdapterCommand";
import { GetAdapterVersionCommandInput, GetAdapterVersionCommandOutput } from "../commands/GetAdapterVersionCommand";
import { GetDocumentAnalysisCommandInput, GetDocumentAnalysisCommandOutput } from "../commands/GetDocumentAnalysisCommand";
import { GetDocumentTextDetectionCommandInput, GetDocumentTextDetectionCommandOutput } from "../commands/GetDocumentTextDetectionCommand";
import { GetExpenseAnalysisCommandInput, GetExpenseAnalysisCommandOutput } from "../commands/GetExpenseAnalysisCommand";
import { GetLendingAnalysisCommandInput, GetLendingAnalysisCommandOutput } from "../commands/GetLendingAnalysisCommand";
import { GetLendingAnalysisSummaryCommandInput, GetLendingAnalysisSummaryCommandOutput } from "../commands/GetLendingAnalysisSummaryCommand";
import { ListAdaptersCommandInput, ListAdaptersCommandOutput } from "../commands/ListAdaptersCommand";
import { ListAdapterVersionsCommandInput, ListAdapterVersionsCommandOutput } from "../commands/ListAdapterVersionsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { StartDocumentAnalysisCommandInput, StartDocumentAnalysisCommandOutput } from "../commands/StartDocumentAnalysisCommand";
import { StartDocumentTextDetectionCommandInput, StartDocumentTextDetectionCommandOutput } from "../commands/StartDocumentTextDetectionCommand";
import { StartExpenseAnalysisCommandInput, StartExpenseAnalysisCommandOutput } from "../commands/StartExpenseAnalysisCommand";
import { StartLendingAnalysisCommandInput, StartLendingAnalysisCommandOutput } from "../commands/StartLendingAnalysisCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateAdapterCommandInput, UpdateAdapterCommandOutput } from "../commands/UpdateAdapterCommand";
/**
 * serializeAws_json1_1AnalyzeDocumentCommand
 */
export declare const se_AnalyzeDocumentCommand: (input: AnalyzeDocumentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1AnalyzeExpenseCommand
 */
export declare const se_AnalyzeExpenseCommand: (input: AnalyzeExpenseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1AnalyzeIDCommand
 */
export declare const se_AnalyzeIDCommand: (input: AnalyzeIDCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateAdapterCommand
 */
export declare const se_CreateAdapterCommand: (input: CreateAdapterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateAdapterVersionCommand
 */
export declare const se_CreateAdapterVersionCommand: (input: CreateAdapterVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteAdapterCommand
 */
export declare const se_DeleteAdapterCommand: (input: DeleteAdapterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteAdapterVersionCommand
 */
export declare const se_DeleteAdapterVersionCommand: (input: DeleteAdapterVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DetectDocumentTextCommand
 */
export declare const se_DetectDocumentTextCommand: (input: DetectDocumentTextCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetAdapterCommand
 */
export declare const se_GetAdapterCommand: (input: GetAdapterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetAdapterVersionCommand
 */
export declare const se_GetAdapterVersionCommand: (input: GetAdapterVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDocumentAnalysisCommand
 */
export declare const se_GetDocumentAnalysisCommand: (input: GetDocumentAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetDocumentTextDetectionCommand
 */
export declare const se_GetDocumentTextDetectionCommand: (input: GetDocumentTextDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetExpenseAnalysisCommand
 */
export declare const se_GetExpenseAnalysisCommand: (input: GetExpenseAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetLendingAnalysisCommand
 */
export declare const se_GetLendingAnalysisCommand: (input: GetLendingAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetLendingAnalysisSummaryCommand
 */
export declare const se_GetLendingAnalysisSummaryCommand: (input: GetLendingAnalysisSummaryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAdaptersCommand
 */
export declare const se_ListAdaptersCommand: (input: ListAdaptersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListAdapterVersionsCommand
 */
export declare const se_ListAdapterVersionsCommand: (input: ListAdapterVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartDocumentAnalysisCommand
 */
export declare const se_StartDocumentAnalysisCommand: (input: StartDocumentAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartDocumentTextDetectionCommand
 */
export declare const se_StartDocumentTextDetectionCommand: (input: StartDocumentTextDetectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartExpenseAnalysisCommand
 */
export declare const se_StartExpenseAnalysisCommand: (input: StartExpenseAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartLendingAnalysisCommand
 */
export declare const se_StartLendingAnalysisCommand: (input: StartLendingAnalysisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateAdapterCommand
 */
export declare const se_UpdateAdapterCommand: (input: UpdateAdapterCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1AnalyzeDocumentCommand
 */
export declare const de_AnalyzeDocumentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AnalyzeDocumentCommandOutput>;
/**
 * deserializeAws_json1_1AnalyzeExpenseCommand
 */
export declare const de_AnalyzeExpenseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AnalyzeExpenseCommandOutput>;
/**
 * deserializeAws_json1_1AnalyzeIDCommand
 */
export declare const de_AnalyzeIDCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AnalyzeIDCommandOutput>;
/**
 * deserializeAws_json1_1CreateAdapterCommand
 */
export declare const de_CreateAdapterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateAdapterCommandOutput>;
/**
 * deserializeAws_json1_1CreateAdapterVersionCommand
 */
export declare const de_CreateAdapterVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateAdapterVersionCommandOutput>;
/**
 * deserializeAws_json1_1DeleteAdapterCommand
 */
export declare const de_DeleteAdapterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAdapterCommandOutput>;
/**
 * deserializeAws_json1_1DeleteAdapterVersionCommand
 */
export declare const de_DeleteAdapterVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAdapterVersionCommandOutput>;
/**
 * deserializeAws_json1_1DetectDocumentTextCommand
 */
export declare const de_DetectDocumentTextCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DetectDocumentTextCommandOutput>;
/**
 * deserializeAws_json1_1GetAdapterCommand
 */
export declare const de_GetAdapterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAdapterCommandOutput>;
/**
 * deserializeAws_json1_1GetAdapterVersionCommand
 */
export declare const de_GetAdapterVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAdapterVersionCommandOutput>;
/**
 * deserializeAws_json1_1GetDocumentAnalysisCommand
 */
export declare const de_GetDocumentAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDocumentAnalysisCommandOutput>;
/**
 * deserializeAws_json1_1GetDocumentTextDetectionCommand
 */
export declare const de_GetDocumentTextDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDocumentTextDetectionCommandOutput>;
/**
 * deserializeAws_json1_1GetExpenseAnalysisCommand
 */
export declare const de_GetExpenseAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetExpenseAnalysisCommandOutput>;
/**
 * deserializeAws_json1_1GetLendingAnalysisCommand
 */
export declare const de_GetLendingAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLendingAnalysisCommandOutput>;
/**
 * deserializeAws_json1_1GetLendingAnalysisSummaryCommand
 */
export declare const de_GetLendingAnalysisSummaryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetLendingAnalysisSummaryCommandOutput>;
/**
 * deserializeAws_json1_1ListAdaptersCommand
 */
export declare const de_ListAdaptersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAdaptersCommandOutput>;
/**
 * deserializeAws_json1_1ListAdapterVersionsCommand
 */
export declare const de_ListAdapterVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListAdapterVersionsCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1StartDocumentAnalysisCommand
 */
export declare const de_StartDocumentAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartDocumentAnalysisCommandOutput>;
/**
 * deserializeAws_json1_1StartDocumentTextDetectionCommand
 */
export declare const de_StartDocumentTextDetectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartDocumentTextDetectionCommandOutput>;
/**
 * deserializeAws_json1_1StartExpenseAnalysisCommand
 */
export declare const de_StartExpenseAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartExpenseAnalysisCommandOutput>;
/**
 * deserializeAws_json1_1StartLendingAnalysisCommand
 */
export declare const de_StartLendingAnalysisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartLendingAnalysisCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateAdapterCommand
 */
export declare const de_UpdateAdapterCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateAdapterCommandOutput>;
