import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import {
  AnalyzeDocumentCommandInput,
  AnalyzeDocumentCommandOutput,
} from "./commands/AnalyzeDocumentCommand";
import {
  AnalyzeExpenseCommandInput,
  AnalyzeExpenseCommandOutput,
} from "./commands/AnalyzeExpenseCommand";
import {
  AnalyzeIDCommandInput,
  AnalyzeIDCommandOutput,
} from "./commands/AnalyzeIDCommand";
import {
  CreateAdapterCommandInput,
  CreateAdapterCommandOutput,
} from "./commands/CreateAdapterCommand";
import {
  CreateAdapterVersionCommandInput,
  CreateAdapterVersionCommandOutput,
} from "./commands/CreateAdapterVersionCommand";
import {
  DeleteAdapterCommandInput,
  DeleteAdapterCommandOutput,
} from "./commands/DeleteAdapterCommand";
import {
  DeleteAdapterVersionCommandInput,
  DeleteAdapterVersionCommandOutput,
} from "./commands/DeleteAdapterVersionCommand";
import {
  DetectDocumentTextCommandInput,
  DetectDocumentTextCommandOutput,
} from "./commands/DetectDocumentTextCommand";
import {
  GetAdapterCommandInput,
  GetAdapterCommandOutput,
} from "./commands/GetAdapterCommand";
import {
  GetAdapterVersionCommandInput,
  GetAdapterVersionCommandOutput,
} from "./commands/GetAdapterVersionCommand";
import {
  GetDocumentAnalysisCommandInput,
  GetDocumentAnalysisCommandOutput,
} from "./commands/GetDocumentAnalysisCommand";
import {
  GetDocumentTextDetectionCommandInput,
  GetDocumentTextDetectionCommandOutput,
} from "./commands/GetDocumentTextDetectionCommand";
import {
  GetExpenseAnalysisCommandInput,
  GetExpenseAnalysisCommandOutput,
} from "./commands/GetExpenseAnalysisCommand";
import {
  GetLendingAnalysisCommandInput,
  GetLendingAnalysisCommandOutput,
} from "./commands/GetLendingAnalysisCommand";
import {
  GetLendingAnalysisSummaryCommandInput,
  GetLendingAnalysisSummaryCommandOutput,
} from "./commands/GetLendingAnalysisSummaryCommand";
import {
  ListAdaptersCommandInput,
  ListAdaptersCommandOutput,
} from "./commands/ListAdaptersCommand";
import {
  ListAdapterVersionsCommandInput,
  ListAdapterVersionsCommandOutput,
} from "./commands/ListAdapterVersionsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  StartDocumentAnalysisCommandInput,
  StartDocumentAnalysisCommandOutput,
} from "./commands/StartDocumentAnalysisCommand";
import {
  StartDocumentTextDetectionCommandInput,
  StartDocumentTextDetectionCommandOutput,
} from "./commands/StartDocumentTextDetectionCommand";
import {
  StartExpenseAnalysisCommandInput,
  StartExpenseAnalysisCommandOutput,
} from "./commands/StartExpenseAnalysisCommand";
import {
  StartLendingAnalysisCommandInput,
  StartLendingAnalysisCommandOutput,
} from "./commands/StartLendingAnalysisCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateAdapterCommandInput,
  UpdateAdapterCommandOutput,
} from "./commands/UpdateAdapterCommand";
import { TextractClient } from "./TextractClient";
export interface Textract {
  analyzeDocument(
    args: AnalyzeDocumentCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AnalyzeDocumentCommandOutput>;
  analyzeDocument(
    args: AnalyzeDocumentCommandInput,
    cb: (err: any, data?: AnalyzeDocumentCommandOutput) => void
  ): void;
  analyzeDocument(
    args: AnalyzeDocumentCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AnalyzeDocumentCommandOutput) => void
  ): void;
  analyzeExpense(
    args: AnalyzeExpenseCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AnalyzeExpenseCommandOutput>;
  analyzeExpense(
    args: AnalyzeExpenseCommandInput,
    cb: (err: any, data?: AnalyzeExpenseCommandOutput) => void
  ): void;
  analyzeExpense(
    args: AnalyzeExpenseCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AnalyzeExpenseCommandOutput) => void
  ): void;
  analyzeID(
    args: AnalyzeIDCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AnalyzeIDCommandOutput>;
  analyzeID(
    args: AnalyzeIDCommandInput,
    cb: (err: any, data?: AnalyzeIDCommandOutput) => void
  ): void;
  analyzeID(
    args: AnalyzeIDCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AnalyzeIDCommandOutput) => void
  ): void;
  createAdapter(
    args: CreateAdapterCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateAdapterCommandOutput>;
  createAdapter(
    args: CreateAdapterCommandInput,
    cb: (err: any, data?: CreateAdapterCommandOutput) => void
  ): void;
  createAdapter(
    args: CreateAdapterCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateAdapterCommandOutput) => void
  ): void;
  createAdapterVersion(
    args: CreateAdapterVersionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateAdapterVersionCommandOutput>;
  createAdapterVersion(
    args: CreateAdapterVersionCommandInput,
    cb: (err: any, data?: CreateAdapterVersionCommandOutput) => void
  ): void;
  createAdapterVersion(
    args: CreateAdapterVersionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateAdapterVersionCommandOutput) => void
  ): void;
  deleteAdapter(
    args: DeleteAdapterCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteAdapterCommandOutput>;
  deleteAdapter(
    args: DeleteAdapterCommandInput,
    cb: (err: any, data?: DeleteAdapterCommandOutput) => void
  ): void;
  deleteAdapter(
    args: DeleteAdapterCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteAdapterCommandOutput) => void
  ): void;
  deleteAdapterVersion(
    args: DeleteAdapterVersionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteAdapterVersionCommandOutput>;
  deleteAdapterVersion(
    args: DeleteAdapterVersionCommandInput,
    cb: (err: any, data?: DeleteAdapterVersionCommandOutput) => void
  ): void;
  deleteAdapterVersion(
    args: DeleteAdapterVersionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteAdapterVersionCommandOutput) => void
  ): void;
  detectDocumentText(
    args: DetectDocumentTextCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DetectDocumentTextCommandOutput>;
  detectDocumentText(
    args: DetectDocumentTextCommandInput,
    cb: (err: any, data?: DetectDocumentTextCommandOutput) => void
  ): void;
  detectDocumentText(
    args: DetectDocumentTextCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DetectDocumentTextCommandOutput) => void
  ): void;
  getAdapter(
    args: GetAdapterCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetAdapterCommandOutput>;
  getAdapter(
    args: GetAdapterCommandInput,
    cb: (err: any, data?: GetAdapterCommandOutput) => void
  ): void;
  getAdapter(
    args: GetAdapterCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetAdapterCommandOutput) => void
  ): void;
  getAdapterVersion(
    args: GetAdapterVersionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetAdapterVersionCommandOutput>;
  getAdapterVersion(
    args: GetAdapterVersionCommandInput,
    cb: (err: any, data?: GetAdapterVersionCommandOutput) => void
  ): void;
  getAdapterVersion(
    args: GetAdapterVersionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetAdapterVersionCommandOutput) => void
  ): void;
  getDocumentAnalysis(
    args: GetDocumentAnalysisCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetDocumentAnalysisCommandOutput>;
  getDocumentAnalysis(
    args: GetDocumentAnalysisCommandInput,
    cb: (err: any, data?: GetDocumentAnalysisCommandOutput) => void
  ): void;
  getDocumentAnalysis(
    args: GetDocumentAnalysisCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetDocumentAnalysisCommandOutput) => void
  ): void;
  getDocumentTextDetection(
    args: GetDocumentTextDetectionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetDocumentTextDetectionCommandOutput>;
  getDocumentTextDetection(
    args: GetDocumentTextDetectionCommandInput,
    cb: (err: any, data?: GetDocumentTextDetectionCommandOutput) => void
  ): void;
  getDocumentTextDetection(
    args: GetDocumentTextDetectionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetDocumentTextDetectionCommandOutput) => void
  ): void;
  getExpenseAnalysis(
    args: GetExpenseAnalysisCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetExpenseAnalysisCommandOutput>;
  getExpenseAnalysis(
    args: GetExpenseAnalysisCommandInput,
    cb: (err: any, data?: GetExpenseAnalysisCommandOutput) => void
  ): void;
  getExpenseAnalysis(
    args: GetExpenseAnalysisCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetExpenseAnalysisCommandOutput) => void
  ): void;
  getLendingAnalysis(
    args: GetLendingAnalysisCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetLendingAnalysisCommandOutput>;
  getLendingAnalysis(
    args: GetLendingAnalysisCommandInput,
    cb: (err: any, data?: GetLendingAnalysisCommandOutput) => void
  ): void;
  getLendingAnalysis(
    args: GetLendingAnalysisCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetLendingAnalysisCommandOutput) => void
  ): void;
  getLendingAnalysisSummary(
    args: GetLendingAnalysisSummaryCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetLendingAnalysisSummaryCommandOutput>;
  getLendingAnalysisSummary(
    args: GetLendingAnalysisSummaryCommandInput,
    cb: (err: any, data?: GetLendingAnalysisSummaryCommandOutput) => void
  ): void;
  getLendingAnalysisSummary(
    args: GetLendingAnalysisSummaryCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetLendingAnalysisSummaryCommandOutput) => void
  ): void;
  listAdapters(): Promise<ListAdaptersCommandOutput>;
  listAdapters(
    args: ListAdaptersCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListAdaptersCommandOutput>;
  listAdapters(
    args: ListAdaptersCommandInput,
    cb: (err: any, data?: ListAdaptersCommandOutput) => void
  ): void;
  listAdapters(
    args: ListAdaptersCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListAdaptersCommandOutput) => void
  ): void;
  listAdapterVersions(): Promise<ListAdapterVersionsCommandOutput>;
  listAdapterVersions(
    args: ListAdapterVersionsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListAdapterVersionsCommandOutput>;
  listAdapterVersions(
    args: ListAdapterVersionsCommandInput,
    cb: (err: any, data?: ListAdapterVersionsCommandOutput) => void
  ): void;
  listAdapterVersions(
    args: ListAdapterVersionsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListAdapterVersionsCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForResourceCommandOutput>;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  startDocumentAnalysis(
    args: StartDocumentAnalysisCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartDocumentAnalysisCommandOutput>;
  startDocumentAnalysis(
    args: StartDocumentAnalysisCommandInput,
    cb: (err: any, data?: StartDocumentAnalysisCommandOutput) => void
  ): void;
  startDocumentAnalysis(
    args: StartDocumentAnalysisCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartDocumentAnalysisCommandOutput) => void
  ): void;
  startDocumentTextDetection(
    args: StartDocumentTextDetectionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartDocumentTextDetectionCommandOutput>;
  startDocumentTextDetection(
    args: StartDocumentTextDetectionCommandInput,
    cb: (err: any, data?: StartDocumentTextDetectionCommandOutput) => void
  ): void;
  startDocumentTextDetection(
    args: StartDocumentTextDetectionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartDocumentTextDetectionCommandOutput) => void
  ): void;
  startExpenseAnalysis(
    args: StartExpenseAnalysisCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartExpenseAnalysisCommandOutput>;
  startExpenseAnalysis(
    args: StartExpenseAnalysisCommandInput,
    cb: (err: any, data?: StartExpenseAnalysisCommandOutput) => void
  ): void;
  startExpenseAnalysis(
    args: StartExpenseAnalysisCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartExpenseAnalysisCommandOutput) => void
  ): void;
  startLendingAnalysis(
    args: StartLendingAnalysisCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartLendingAnalysisCommandOutput>;
  startLendingAnalysis(
    args: StartLendingAnalysisCommandInput,
    cb: (err: any, data?: StartLendingAnalysisCommandOutput) => void
  ): void;
  startLendingAnalysis(
    args: StartLendingAnalysisCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartLendingAnalysisCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagResourceCommandOutput>;
  tagResource(
    args: TagResourceCommandInput,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagResourceCommandOutput>;
  untagResource(
    args: UntagResourceCommandInput,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  updateAdapter(
    args: UpdateAdapterCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateAdapterCommandOutput>;
  updateAdapter(
    args: UpdateAdapterCommandInput,
    cb: (err: any, data?: UpdateAdapterCommandOutput) => void
  ): void;
  updateAdapter(
    args: UpdateAdapterCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateAdapterCommandOutput) => void
  ): void;
}
export declare class Textract extends TextractClient implements Textract {}
