import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { TextractClientResolvedConfig } from "../TextractClient";
export interface TextractHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface TextractHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    TextractClientResolvedConfig,
    HandlerExecutionContext,
    TextractHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultTextractHttpAuthSchemeParametersProvider: (
  config: TextractClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<TextractHttpAuthSchemeParameters>;
export interface TextractHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<TextractHttpAuthSchemeParameters> {}
export declare const defaultTextractHttpAuthSchemeProvider: TextractHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: TextractHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: TextractHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
