import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  AnalyzeDocumentCommandInput,
  AnalyzeDocumentCommandOutput,
} from "../commands/AnalyzeDocumentCommand";
import {
  AnalyzeExpenseCommandInput,
  AnalyzeExpenseCommandOutput,
} from "../commands/AnalyzeExpenseCommand";
import {
  AnalyzeIDCommandInput,
  AnalyzeIDCommandOutput,
} from "../commands/AnalyzeIDCommand";
import {
  CreateAdapterCommandInput,
  CreateAdapterCommandOutput,
} from "../commands/CreateAdapterCommand";
import {
  CreateAdapterVersionCommandInput,
  CreateAdapterVersionCommandOutput,
} from "../commands/CreateAdapterVersionCommand";
import {
  DeleteAdapterCommandInput,
  DeleteAdapterCommandOutput,
} from "../commands/DeleteAdapterCommand";
import {
  DeleteAdapterVersionCommandInput,
  DeleteAdapterVersionCommandOutput,
} from "../commands/DeleteAdapterVersionCommand";
import {
  DetectDocumentTextCommandInput,
  DetectDocumentTextCommandOutput,
} from "../commands/DetectDocumentTextCommand";
import {
  GetAdapterCommandInput,
  GetAdapterCommandOutput,
} from "../commands/GetAdapterCommand";
import {
  GetAdapterVersionCommandInput,
  GetAdapterVersionCommandOutput,
} from "../commands/GetAdapterVersionCommand";
import {
  GetDocumentAnalysisCommandInput,
  GetDocumentAnalysisCommandOutput,
} from "../commands/GetDocumentAnalysisCommand";
import {
  GetDocumentTextDetectionCommandInput,
  GetDocumentTextDetectionCommandOutput,
} from "../commands/GetDocumentTextDetectionCommand";
import {
  GetExpenseAnalysisCommandInput,
  GetExpenseAnalysisCommandOutput,
} from "../commands/GetExpenseAnalysisCommand";
import {
  GetLendingAnalysisCommandInput,
  GetLendingAnalysisCommandOutput,
} from "../commands/GetLendingAnalysisCommand";
import {
  GetLendingAnalysisSummaryCommandInput,
  GetLendingAnalysisSummaryCommandOutput,
} from "../commands/GetLendingAnalysisSummaryCommand";
import {
  ListAdaptersCommandInput,
  ListAdaptersCommandOutput,
} from "../commands/ListAdaptersCommand";
import {
  ListAdapterVersionsCommandInput,
  ListAdapterVersionsCommandOutput,
} from "../commands/ListAdapterVersionsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "../commands/ListTagsForResourceCommand";
import {
  StartDocumentAnalysisCommandInput,
  StartDocumentAnalysisCommandOutput,
} from "../commands/StartDocumentAnalysisCommand";
import {
  StartDocumentTextDetectionCommandInput,
  StartDocumentTextDetectionCommandOutput,
} from "../commands/StartDocumentTextDetectionCommand";
import {
  StartExpenseAnalysisCommandInput,
  StartExpenseAnalysisCommandOutput,
} from "../commands/StartExpenseAnalysisCommand";
import {
  StartLendingAnalysisCommandInput,
  StartLendingAnalysisCommandOutput,
} from "../commands/StartLendingAnalysisCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateAdapterCommandInput,
  UpdateAdapterCommandOutput,
} from "../commands/UpdateAdapterCommand";
export declare const se_AnalyzeDocumentCommand: (
  input: AnalyzeDocumentCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_AnalyzeExpenseCommand: (
  input: AnalyzeExpenseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_AnalyzeIDCommand: (
  input: AnalyzeIDCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateAdapterCommand: (
  input: CreateAdapterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateAdapterVersionCommand: (
  input: CreateAdapterVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteAdapterCommand: (
  input: DeleteAdapterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteAdapterVersionCommand: (
  input: DeleteAdapterVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DetectDocumentTextCommand: (
  input: DetectDocumentTextCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetAdapterCommand: (
  input: GetAdapterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetAdapterVersionCommand: (
  input: GetAdapterVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDocumentAnalysisCommand: (
  input: GetDocumentAnalysisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDocumentTextDetectionCommand: (
  input: GetDocumentTextDetectionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetExpenseAnalysisCommand: (
  input: GetExpenseAnalysisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetLendingAnalysisCommand: (
  input: GetLendingAnalysisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetLendingAnalysisSummaryCommand: (
  input: GetLendingAnalysisSummaryCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListAdaptersCommand: (
  input: ListAdaptersCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListAdapterVersionsCommand: (
  input: ListAdapterVersionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTagsForResourceCommand: (
  input: ListTagsForResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_StartDocumentAnalysisCommand: (
  input: StartDocumentAnalysisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_StartDocumentTextDetectionCommand: (
  input: StartDocumentTextDetectionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_StartExpenseAnalysisCommand: (
  input: StartExpenseAnalysisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_StartLendingAnalysisCommand: (
  input: StartLendingAnalysisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateAdapterCommand: (
  input: UpdateAdapterCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_AnalyzeDocumentCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<AnalyzeDocumentCommandOutput>;
export declare const de_AnalyzeExpenseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<AnalyzeExpenseCommandOutput>;
export declare const de_AnalyzeIDCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<AnalyzeIDCommandOutput>;
export declare const de_CreateAdapterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateAdapterCommandOutput>;
export declare const de_CreateAdapterVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateAdapterVersionCommandOutput>;
export declare const de_DeleteAdapterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteAdapterCommandOutput>;
export declare const de_DeleteAdapterVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteAdapterVersionCommandOutput>;
export declare const de_DetectDocumentTextCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DetectDocumentTextCommandOutput>;
export declare const de_GetAdapterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAdapterCommandOutput>;
export declare const de_GetAdapterVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAdapterVersionCommandOutput>;
export declare const de_GetDocumentAnalysisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDocumentAnalysisCommandOutput>;
export declare const de_GetDocumentTextDetectionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDocumentTextDetectionCommandOutput>;
export declare const de_GetExpenseAnalysisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetExpenseAnalysisCommandOutput>;
export declare const de_GetLendingAnalysisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetLendingAnalysisCommandOutput>;
export declare const de_GetLendingAnalysisSummaryCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetLendingAnalysisSummaryCommandOutput>;
export declare const de_ListAdaptersCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListAdaptersCommandOutput>;
export declare const de_ListAdapterVersionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListAdapterVersionsCommandOutput>;
export declare const de_ListTagsForResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForResourceCommandOutput>;
export declare const de_StartDocumentAnalysisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StartDocumentAnalysisCommandOutput>;
export declare const de_StartDocumentTextDetectionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StartDocumentTextDetectionCommandOutput>;
export declare const de_StartExpenseAnalysisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StartExpenseAnalysisCommandOutput>;
export declare const de_StartLendingAnalysisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StartLendingAnalysisCommandOutput>;
export declare const de_TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const de_UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const de_UpdateAdapterCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateAdapterCommandOutput>;
